
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Cart_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const cart_items = await db.cart_items.create(
            {
                id: data.id || undefined,
        
        item_name: data.item_name
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        line_discount_amount: data.line_discount_amount
        ||
        null
            ,
            
        line_tax_amount: data.line_tax_amount
        ||
        null
            ,
            
        line_total_amount: data.line_total_amount
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await cart_items.setCart( data.cart || null, {
            transaction,
        });
        
        await cart_items.setProduct( data.product || null, {
            transaction,
        });
        
        await cart_items.setProduct_variant( data.product_variant || null, {
            transaction,
        });
        
        await cart_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return cart_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const cart_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                item_name: item.item_name
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                line_discount_amount: item.line_discount_amount
            ||
            null
            ,
            
                line_tax_amount: item.line_tax_amount
            ||
            null
            ,
            
                line_total_amount: item.line_total_amount
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const cart_items = await db.cart_items.bulkCreate(cart_itemsData, { transaction });

        // For each item created, replace relation files
        

        return cart_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const cart_items = await db.cart_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.item_name !== undefined) updatePayload.item_name = data.item_name;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.line_discount_amount !== undefined) updatePayload.line_discount_amount = data.line_discount_amount;
        
        
        if (data.line_tax_amount !== undefined) updatePayload.line_tax_amount = data.line_tax_amount;
        
        
        if (data.line_total_amount !== undefined) updatePayload.line_total_amount = data.line_total_amount;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await cart_items.update(updatePayload, {transaction});

        
        
        if (data.cart !== undefined) {
            await cart_items.setCart(
              
              data.cart,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await cart_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.product_variant !== undefined) {
            await cart_items.setProduct_variant(
              
              data.product_variant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await cart_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return cart_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const cart_items = await db.cart_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of cart_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of cart_items) {
                await record.destroy({transaction});
            }
        });


        return cart_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const cart_items = await db.cart_items.findByPk(id, options);

        await cart_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await cart_items.destroy({
            transaction
        });

        return cart_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const cart_items = await db.cart_items.findOne(
            { where },
            { transaction },
        );

        if (!cart_items) {
            return cart_items;
        }

        const output = cart_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.cart = await cart_items.getCart({
            transaction
        });
        
        
        output.product = await cart_items.getProduct({
            transaction
        });
        
        
        output.product_variant = await cart_items.getProduct_variant({
            transaction
        });
        
        
        output.organizations = await cart_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.carts,
        as: 'cart',
        
        where: filter.cart ? {
          [Op.or]: [
            { id: { [Op.in]: filter.cart.split('|').map(term => Utils.uuid(term)) } },
            {
              hold_reason: {
                [Op.or]: filter.cart.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.product_variants,
        as: 'product_variant',
        
        where: filter.product_variant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product_variant.split('|').map(term => Utils.uuid(term)) } },
            {
              variant_name: {
                [Op.or]: filter.product_variant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.item_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'cart_items',
                        'item_name',
                        filter.item_name,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'cart_items',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_discount_amountRange) {
                const [start, end] = filter.line_discount_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_discount_amount: {
                    ...where.line_discount_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_discount_amount: {
                    ...where.line_discount_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_tax_amountRange) {
                const [start, end] = filter.line_tax_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_tax_amount: {
                    ...where.line_tax_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_tax_amount: {
                    ...where.line_tax_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_total_amountRange) {
                const [start, end] = filter.line_total_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_total_amount: {
                    ...where.line_total_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_total_amount: {
                    ...where.line_total_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.cart_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'cart_items',
                        'item_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.cart_items.findAll({
            attributes: [ 'id', 'item_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['item_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.item_name,
        }));
    }

    
};

